routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::view('/', 'welcome', ['name' => 'Prueba'])->name('welcome');

Route::resource('alumno', 'AlumnoController');
Route::resource('user', 'UserController');
Route::resource('empresa', 'EmpresaController');
Route::resource('centro', 'CentroController');
Route::resource('contacto', 'ContactoController');
Route::resource('oferta', 'OfertaController');
Route::resource('inscripcion', 'InscripcionController');

Route::get('download/{id}/{pdf}', 'DownloadController@download');

app/Oferta.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Oferta extends Model
{
    protected $table = 'ofertas';
    protected $fillable = [
        'empresa_id',
        'centro_id',
        'contacto_id',
        'vacantes',
        'descripcion',
        'familia',
        'perfil',
        'tareas',
        'estado'
    ];

    public function empresa()
    {
        return $this->belongsTo('App\Empresa');
    }

    public function centro()
    {
        return $this->belongsTo('App\Centro');
    }

    public function contacto()
    {
        return $this->belongsTo('App\Contacto');
    }

    public function inscripciones()
    {
        return $this->hasMany('App\Inscripcion', 'alumno_id', 'id');
    }
}

app/Http/Controllers/OfertaController.php
<?php

namespace App\Http\Controllers;

use App\Oferta;
use App\Functions;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;

class OfertaController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if (Functions::setValidRole(['empresa'])) {
            $ofertas = Oferta::all()->where('empresa_id', Auth::user()->empresa['id']);
        } else if (Functions::setValidRole(['profesor'])) {
            $ofertas = Oferta::all();
        } else {
            $ofertas = Oferta::all()->where('estado', 'activa');
        }
        if (!$ofertas) { return abort(404); }
        return view('oferta.index', compact('ofertas'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if (!Functions::setValidRole(['empresa'])) {
            return abort(404);
        }

        $centros = Auth::user()->empresa->centros;
        $arrayCentros = null;
        foreach ($centros as $centro) {
            $arrayCentros[$centro->id] = $centro->nombre.' - '.$centro->direccion;
            //$arrayCentros.put($centro->id);
        }

        $contactos = Auth::user()->empresa->contactos;
        $arrayContactos = null;
        foreach ($contactos as $contacto) {
            $contactoPreferido = $contacto->email ? $contacto->email : $contacto->tlf;
            $arrayContactos[$contacto->id] = $contacto->nombre.' - '.$contactoPreferido;
            //$arrayCentros.put($centro->id);
        }

        if (!$arrayCentros || !$arrayContactos || empty($arrayCentros) || empty($arrayContactos)) {
            return redirect()->route('home')->with('info', 'Debes crear antes un centro y un contacto');
        }

        $perfil = Functions::getOpciones();
        //dd($arrayCentros);
        return view('oferta.create', compact('arrayCentros', 'arrayContactos', 'perfil'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if (!Functions::setValidRole(['empresa'])) {
            return abort(404);
        }
        $data = $request->all();
        $data['empresa_id'] = Auth::user()->empresa['id'];
        $oferta = Oferta::create($data);
        if (!$oferta) { return abort(404); }
        return redirect()->route('oferta.index')->with('info', 'Oferta creada');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Oferta  $oferta
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $oferta = Oferta::find($id);
        if (!$oferta) { return abort(404); }
        if (Functions::setValidRole(['empresa']) && !Functions::setValidId($oferta->empresa->id)) {
            return abort(404);
        }
        return view('oferta.show', compact('oferta'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Oferta  $oferta
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $oferta = Oferta::find($id);

        $centros = Auth::user()->empresa->centros;
        $arrayCentros;
        foreach ($centros as $centro) {
            $arrayCentros[$centro->id] = $centro->nombre.' - '.$centro->direccion;
            //$arrayCentros.put($centro->id);
        }

        $contactos = Auth::user()->empresa->contactos;
        $arrayContactos;
        foreach ($contactos as $contacto) {
            $contactoPreferido = $contacto->email ? $contacto->email : $contacto->tlf;
            $arrayContactos[$contacto->id] = $contacto->nombre.' - '.$contactoPreferido;
            //$arrayCentros.put($centro->id);
        }

        if (!$oferta || !$arrayContactos || !$arrayCentros) { return abort(404); }

        if (Functions::setValidRole(['empresa', 'alumno', 'profesor']) && !Functions::setValidId($oferta->empresa->id)) {
            return abort(404);
        }

        $perfil = Functions::getOpciones();
        return view('oferta.edit', compact('oferta', 'arrayCentros', 'arrayContactos','perfil'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Oferta  $oferta
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $oferta = Oferta::find($id);
        $data = $request->all();
        if (!$oferta || !$data) { return abort(404); }
        if (Functions::setValidRole(['empresa', 'alumno', 'profesor']) && !Functions::setValidId($oferta->empresa->id)) {
            return abort(404);
        }
        $oferta->fill($data)->save();
        return redirect()->route('oferta.index')->with('info', 'Oferta actualizada');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Oferta  $oferta
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $oferta = Oferta::find($id);
        if (!$oferta) { return abort(404); }
        if (Functions::setValidRole(['empresa', 'alumno']) && !Functions::setValidId($oferta->empresa->id)) {
            return abort(404);
        }
        $oferta->delete();
        return redirect()->route('oferta.index')->with('info', 'Oferta eliminada');
    }
}

resources/views/oferta/create.blade.php
@extends('layouts.app')

@section('content')
<form method="POST" action="{{ route('oferta.store') }}">
  @csrf
  @include('oferta.partials.form')

  <div class="box-footer">
	  {{ Form::submit('Crear', ['class' => 'btn btn-primary btn-block']) }}
	</div>
</form>
@endsection

resources/views/oferta/edit.blade.php
@extends('layouts.app')

@section('content')
{{ Form::model($oferta, ['route' => ['oferta.update', $oferta], 'method' => 'PUT', 'files' => false]) }}
  @include('oferta.partials.form')
<div>
  {{ Form::submit('Actualizar', ['class' => 'btn btn-primary btn-block']) }}
</div>
{{ Form::close() }}
@endsection

resources/views/oferta/index.blade.php
@extends('layouts.app')

@section('content')
<table class="table table-bordered table-hover" id="example1">
	<thead>
		<tr>
			<th>Empresa</th>
			<th>Nº de vacantes</th>
			<th>Perfil Profesional</th>
			@if (Auth::user()->empresa['id']  || Auth::user()->codigo)
				<th>Estado</th>
			@endif
			<th class="text-center" data-orderable="false">Ver</th>
			@if (Auth::user()->empresa['id'])
				<th class="text-center" data-orderable="false">Editar</th>
			@endif
			@if (Auth::user()->empresa['id'] || Auth::user()->codigo)
				<th class="text-center" data-orderable="false">Borrar</th>
			@endif
		</tr>
	</thead>
	<tbody>
	@foreach ($ofertas as $oferta)
		<tr>
			<td>{{ $oferta->empresa->user['name'] }}</td>
			<td>{{ $oferta->vacantes }}</td>
			<td>{{ $oferta->perfil }}</td>
			@if (Auth::user()->empresa['id'] || Auth::user()->codigo)
				<td>{{ $oferta->estado }}</td>
			@endif
			<td class="text-center">
				<a href="{{ route('oferta.show', $oferta->id) }}" class="btn btn-info">
					<svg class="bi bi-eye-fill text-white" width="1.2em" height="1.2em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
					    <path d="M10.5 8a2.5 2.5 0 1 1-5 0 2.5 2.5 0 0 1 5 0z"/>
					    <path fill-rule="evenodd" d="M0 8s3-5.5 8-5.5S16 8 16 8s-3 5.5-8 5.5S0 8 0 8zm8 3.5a3.5 3.5 0 1 0 0-7 3.5 3.5 0 0 0 0 7z"/>
					</svg>
				</a>
			</td>
				@if (Auth::user()->empresa['id'])
				<td class="text-center">
				<a href="{{ route('oferta.edit', $oferta) }}" class="btn btn-success">
					<svg class="bi bi-pencil text-white" width="1.2em" height="1.2em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
					  	<path fill-rule="evenodd" d="M11.293 1.293a1 1 0 0 1 1.414 0l2 2a1 1 0 0 1 0 1.414l-9 9a1 1 0 0 1-.39.242l-3 1a1 1 0 0 1-1.266-1.265l1-3a1 1 0 0 1 .242-.391l9-9zM12 2l2 2-9 9-3 1 1-3 9-9z"/>
					  	<path fill-rule="evenodd" d="M12.146 6.354l-2.5-2.5.708-.708 2.5 2.5-.707.708zM3 10v.5a.5.5 0 0 0 .5.5H4v.5a.5.5 0 0 0 .5.5H5v.5a.5.5 0 0 0 .5.5H6v-1.5a.5.5 0 0 0-.5-.5H5v-.5a.5.5 0 0 0-.5-.5H3z"/>
					</svg>
				</a>
				</td>
				@endif

				@if (Auth::user()->empresa['id'] || Auth::user()->codigo)
				<td class="text-center">
				{!! Form::open(['route' => ['oferta.destroy', $oferta], 'method' => 'DELETE']) !!}
				<button class="btn btn-danger" onclick="return confirm('¿Estás seguro?')">
					<svg class="bi bi-trash-fill" width="1.2em" height="1.2em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
					  <path fill-rule="evenodd" d="M2.5 1a1 1 0 0 0-1 1v1a1 1 0 0 0 1 1H3v9a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V4h.5a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1H10a1 1 0 0 0-1-1H7a1 1 0 0 0-1 1H2.5zm3 4a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 .5-.5zM8 5a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7A.5.5 0 0 1 8 5zm3 .5a.5.5 0 0 0-1 0v7a.5.5 0 0 0 1 0v-7z"/>
					</svg>
				</button>
				{!! Form::close() !!}
				</td>
				@endif

		</tr>
	@endforeach
	</tbody>
</table>
@if (Auth::user()->empresa['id_fiscal'])
	<a href="{{ route('oferta.create') }}">
	<svg class="bi bi-plus-circle-fill text-secondary" width="3em" height="3em" viewBox="0 0 16 16" fill="currentColor" xmlns="http://www.w3.org/2000/svg" style="display:block;margin:auto;">
	<path fill-rule="evenodd" d="M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0zM8.5 4a.5.5 0 0 0-1 0v3.5H4a.5.5 0 0 0 0 1h3.5V12a.5.5 0 0 0 1 0V8.5H12a.5.5 0 0 0 0-1H8.5V4z"/>
	</svg>
	</a>
@endif
@endsection
@section('scripts')
<script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js"></script>
<script>
  jQuery(function($) {
    $('#example1').DataTable({
    	"order": [[ 1, "desc" ]],
    	"columnDefs": [
                    {
                    	@if (Auth::user()->empresa['id'])
                        	"targets": [ 4, 5, 6 ],
                        @elseif (Auth::user()->alumno['id'])
                        	"targets": [ 3 ],
                		@elseif (Auth::user()->codigo)
                			"targets": [ 4, 5 ],
                        @endif
                        "visible": true,
                        "searchable": false
                    },
        ],
    	"language": {
    		"zeroRecords": "Nada que mostrar",
            "info": "Mostrando _START_ a _END_ de _TOTAL_ ofertas",
            "infoEmpty": "No hay datos disponibles",
            "infoFiltered": "(filtrados de _MAX_ ofertas en total)",
            "sLengthMenu": "Mostrar _MENU_ ofertas",
            "paginate": {
      			"previous": "Anterior",
      			"next": "Siguiente"
    		}
        }
    });
  });
</script>
@endsection

resources/views/oferta/show.blade.php
@extends('layouts.app')

@section('content')
<h2>Oferta</h2>
<div class="list-group">
  <a href="{{ route('empresa.show', $oferta->empresa->id) }}" class="list-group-item list-group-item-action text-primary">Nombre Comercial: {{ $oferta->empresa->user['name'] }}</a>
  <a href="{{ route('centro.show', $oferta->centro->id) }}" class="list-group-item list-group-item-action text-primary">Centro de trabajo: {{ $oferta->centro['nombre'] }}</a>
  <a href="{{ route('contacto.show', $oferta->contacto->id) }}" class="list-group-item list-group-item-action text-primary">Contacto: {{ $oferta->contacto['nombre'] }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Nº Vacantes: {{ $oferta->vacantes }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Familia Profesional: {{ $oferta->familia }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Perfil Profesional: {{ $oferta->perfil }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Tareas recomendadas: {{ $oferta->tareas }}</a>
  <a href="#" class="list-group-item list-group-item-action disabled">Estado: {{ $oferta->estado }}</a>

  @if (Auth::user()->alumno['id'])
    @php
      $flag = true;
    @endphp
    @foreach (Auth::user()->alumno->inscripciones->all() as $inscripcion)
      @if ($inscripcion['oferta_id'] == $oferta->id)
        @php
           $inscripcionId = $inscripcion->id;
           $flag = false;
        @endphp
        {!! Form::open(['route' => ['inscripcion.destroy', $inscripcionId], 'method' => 'DELETE']) !!}
          <button class="btn btn-danger btn-block" onclick="return confirm('¿Estás seguro?')" style="display:inline-block;">Cancelar inscripción</button>
        {!! Form::close() !!}
      @endif
    @endforeach
    @if ($flag)
    {!! Form::open(['route' => ['inscripcion.store', $oferta->id], 'method' => 'POST']) !!}
          {{ Form::text('ofertaId', $oferta->id, ['hidden']) }}
          <button class="btn btn-primary btn-block" style="display:inline-block;">Inscribirse</button>
        {!! Form::close() !!}
    @endif
  @endif
</div>
<a class="btn btn-secondary btn-block mt-4" href="{{ URL::previous() }}">Volver</a>
@endsection

<!-- TODO: arreglar los botones de cancelar inscripción/inscribirse -->